unit P2_cgate_types;

interface

uses
  Cgate_types;

type
//--- node data
  PNodeData = ^TNodeData;
  TNodeData = packed record
    scheme: boolean;
    schemeStr: string;
    SnOnline: integer;
  end;
//--- field
  TField = packed record
    Name: string;
    value: string;
  end;
//--- Table
  TTable = packed record
    Name: string;
    Checked: boolean;
    FielsCnt: integer;
    Fields: array of TField;
  end;
//--- Envirioment
  TEnvironment = packed record
    cnt: integer;
    Ent_name: array of string;
    data: array of string;
  end;
//--- Stream
  TStream = packed record
    Name: string;
    Checked: Boolean;
    Scheme: boolean;
    SchemeStr: string;
    Snonline: integer;
    TblCnt: integer;
    Tables: array of TTable;
  end;
//--- Streams
  TStreams = packed record
    StrCnt: integer;
    Strs: array of TStream;
  end;
//--- Visual
  TVisual = packed record
    Tblcnt: integer;
    Tables: array of TTable;
  end;
//--- out settings
{  TOutSettings = packed record
    EnvStr: string;
    ConnStr: string;
    LstnrCnt: integer;
    ListnrsNew: array of string;
    LOpenParam: array of string;
    Transactions: integer;
  end;}
//--- Options
  TOptions = packed record
    Transactions: integer;
    Protocol: boolean;
    FutDepth: integer;
    OptDepth: integer;
    EntryCnt: integer;
    Ent_name: array of string;
    Ent_values: array of string;
  end;
//--- settings data
  PSetData = ^TSetData;
  TSetData = packed record
    environment: TEnvironment;
    streams: TStreams;
    visual: TVisual;
    options: TOptions;
    outset: TOutSettings;
    GoConnect: boolean;
  end;
//---
const
  ONE_MEG = 1073741824;
//---
var
  SetData: TSetData;

implementation

end.
