unit Settings;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.Menus, Vcl.Buttons, Winapi.ShlObj,
  Vcl.ComCtrls, Vcl.CheckLst, Vcl.ImgList, P2_cgate_types, ModeDialog,
  Vcl.Samples.Spin, Vcl.ExtCtrls;

type
  TSetForm = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Edit1: TEdit;
    Edit5: TEdit;
    StaticText1: TStaticText;
    StaticText2: TStaticText;
    StaticText3: TStaticText;
    PopupMenu1: TPopupMenu;
    N1: TMenuItem;
    N2: TMenuItem;
    CheckBox1: TCheckBox;
    TreeView1: TTreeView;
    ImageList1: TImageList;
    StaticText18: TStaticText;
    SpinEdit1: TSpinEdit;
    StaticText4: TStaticText;
    StaticText5: TStaticText;
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    Edit3: TEdit;
    Edit2: TEdit;
    Edit4: TEdit;
    GroupBox3: TGroupBox;
    StaticText6: TStaticText;
    Edit6: TEdit;
    Edit7: TEdit;
    StaticText7: TStaticText;
    StaticText8: TStaticText;
    Edit8: TEdit;
    StaticText9: TStaticText;
    Edit9: TEdit;
    StaticText10: TStaticText;
    Edit10: TEdit;
    StaticText11: TStaticText;
    Edit11: TEdit;
    StaticText12: TStaticText;
    Edit12: TEdit;
    StaticText13: TStaticText;
    Edit13: TEdit;
    StaticText14: TStaticText;
    Edit14: TEdit;
    GroupBox4: TGroupBox;
    PopupMenu2: TPopupMenu;
    N3: TMenuItem;
    N4: TMenuItem;
    RadioGroup1: TRadioGroup;
    RadioGroup2: TRadioGroup;
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure N1Click(Sender: TObject);
    procedure N2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure TreeView1DblClick(Sender: TObject);
    procedure TreeView1Click(Sender: TObject);
    procedure TreeView1ContextPopup(Sender: TObject; MousePos: TPoint;
      var Handled: Boolean);
    procedure CheckBox1Click(Sender: TObject);
    procedure N3Click(Sender: TObject);
    procedure N4Click(Sender: TObject);
    procedure SpinEdit1Change(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  SetForm: TSetForm;

implementation

{$R *.dfm}

procedure TSetForm.CheckBox1Click(Sender: TObject);
begin
  if (CheckBox1.Checked) then
  begin
    Edit6.Text:= 'p2lrpcq';
    Edit12.Enabled:= true;
    Edit14.Enabled:= true;
  end else
  begin
    Edit6.Text:= 'p2tcp';
    Edit12.Enabled:= false;
    Edit14.Enabled:= false;
  end;
end;

procedure TSetForm.Button1Click(Sender: TObject);
begin
  SetForm.ModalResult:= mrOk;
end;

procedure TSetForm.Button2Click(Sender: TObject);
begin
  Close();
end;

procedure TSetForm.FormCreate(Sender: TObject);
begin
  Edit5.PasswordChar:= '*';
  N1.Checked:= false;
  N2.Checked:= true;
  Edit10.PasswordChar:= '*';
  N3.Checked:= false;
  N4.Checked:= true;
end;

procedure TSetForm.N1Click(Sender: TObject);
begin
  Edit5.PasswordChar:= #0;
  N1.Checked:= true;
  N2.Checked:= false;
end;

procedure TSetForm.N2Click(Sender: TObject);
begin
  Edit5.PasswordChar:= '*';
  N1.Checked:= false;
  N2.Checked:= true;
end;

procedure TSetForm.N3Click(Sender: TObject);
begin
  Edit10.PasswordChar:= #0;
  N3.Checked:= true;
  N4.Checked:= false;
end;

procedure TSetForm.N4Click(Sender: TObject);
begin
  Edit10.PasswordChar:= '*';
  N3.Checked:= false;
  N4.Checked:= true;
end;


procedure TSetForm.SpinEdit1Change(Sender: TObject);
begin
  if (SpinEdit1.Value <= 0) then SpinEdit1.Value:= 1;
end;

procedure TSetForm.TreeView1Click(Sender: TObject);
var
  P: TPoint;
  i: integer;
  Node, NextNode, ParentNode: TTreeNode;
  is_found: boolean;
begin
  GetCursorPos(P);
  P:= TreeView1.ScreenToClient(P);
  if (htOnIcon in TreeView1.GetHitTestInfoAt(P.X, P.Y)) then
  begin
    TreeView1.Items.BeginUpdate;
    try
      Node:= TreeView1.Selected;
      ParentNode:= Node.Parent;
      if(Node.ImageIndex = 0) then
      begin
        Node.ImageIndex:= 1;
        Node.SelectedIndex:= 1;
        if ((Node.Text = 'FORTS_FUTAGGRXX_REPL') or
           ((Node.Text = 'orders_aggr') and (ParentNode.Text = 'FORTS_FUTAGGRXX_REPL'))) then
          RadioGroup1.Enabled:= true;
        if ((Node.Text = 'FORTS_OPTAGGRXX_REPL') or
           ((Node.Text = 'orders_aggr') and (ParentNode.Text = 'FORTS_OPTAGGRXX_REPL'))) then
          RadioGroup2.Enabled:= true;
      end else
      begin
        Node.ImageIndex:= 0;
        Node.SelectedIndex:= 0;
        if ((Node.Text = 'FORTS_FUTAGGRXX_REPL') or
           ((Node.Text = 'orders_aggr') and (ParentNode.Text = 'FORTS_FUTAGGRXX_REPL'))) then
          RadioGroup1.Enabled:= false;
        if ((Node.Text = 'FORTS_OPTAGGRXX_REPL') or
           ((Node.Text = 'orders_aggr') and (ParentNode.Text = 'FORTS_OPTAGGRXX_REPL'))) then
          RadioGroup2.Enabled:= false;
      end;
      if(Node.Count > 0) then
      begin
        for i:= 0 to node.Count - 1  do
        begin
          NextNode:= node.Item[i];
          NextNode.ImageIndex:= Node.ImageIndex;
          NextNode.SelectedIndex:= Node.SelectedIndex;
        end;
      end else
      begin
        ParentNode:= node.Parent;
        if (node.ImageIndex = 1) then
        begin
          ParentNode.ImageIndex:= node.ImageIndex;
          ParentNode.SelectedIndex:= node.ImageIndex;
        end else
        begin
          if (ParentNode.Count > 0) then
          begin
            is_found:= false;
            for i:= 0 to ParentNode.Count - 1  do
            begin
              nextNode:= ParentNode.Item[i];
              if(nextNode.ImageIndex <> node.ImageIndex) then
              begin
                is_found:= true;
                break;
              end;
            end;
            if (not is_found) then
            begin
              ParentNode.ImageIndex:= Node.ImageIndex;
              ParentNode.SelectedIndex:= Node.ImageIndex;
            end;
          end;
        end;
      end;
//--- expamd child nodes
      if(Node.Count > 0) then
        if (Node.ImageIndex = 1) then Node.Expand(true) else Node.Collapse(true);
//--- autoscroll
      //TreeView1.TopItem:= node;//????????????????????????????
    finally
      TreeView1.Items.EndUpdate;
    end;
  end;
end;

procedure TSetForm.TreeView1ContextPopup(Sender: TObject; MousePos: TPoint;
  var Handled: Boolean);
var
  node: TTreenode;
  nData: PNodeData;
begin
//--- set stram mode (online snapshot )
  TreeView1.Items.BeginUpdate;
  try
    node:= TreeView1.Selected;
    if(node.Count > 0) then
    begin
      ModeDlg:= TOKRightDlg.Create(self);
      try
        nData:= node.Data;
        ModeDlg.CheckBox1.Checked:= nData^.scheme;
        ModeDlg.RadioGroup1.ItemIndex:= nData^.SnOnline;
        ModeDlg.Edit1.Text:= nData^.schemeStr;
        ModeDlg.CheckBox1Click(self);
        ModeDlg.ShowModal;
        if(ModeDlg.ModalResult = mrOk) then
        begin
          nData^.SnOnline:= ModeDlg.RadioGroup1.ItemIndex;
          nData^.scheme:= ModeDlg.CheckBox1.Checked;
          nData^.schemeStr:= ModeDlg.Edit1.Text;
        end;
      finally
        ModeDlg.Free;
      end;
    end;
  finally
    TreeView1.Items.EndUpdate;
  end;
end;

procedure TSetForm.TreeView1DblClick(Sender: TObject);
var
  P: TPoint;
  Node: TTreeNode;
begin
//--- Set disable expand collapse
  TreeView1.Items.BeginUpdate;
  try
    GetCursorPos(P);
    P:= TreeView1.ScreenToClient(P);
    if (htOnItem in TreeView1.GetHitTestInfoAt(P.X, P.Y)) then
    begin
      Node:= TreeView1.Selected;
        if (Node.Expanded) then Node.Collapse(false) else
          Node.Expand(false);
    end;
  finally
    TreeView1.Items.EndUpdate;
  end;
end;


end.
